package org.w3c.dom.ranges;

import org.w3c.dom.DocumentFragment;
import org.w3c.dom.DOMException;
import org.w3c.dom.Node;

public interface Range
{
    public static final short START_TO_START = 0;
    public static final short START_TO_END = 1;
    public static final short END_TO_END = 2;
    public static final short END_TO_START = 3;
    
    public abstract Node getStartContainer() throws DOMException;
    
    public abstract int getStartOffset() throws DOMException;
    
    public abstract Node getEndContainer() throws DOMException;
    
    public abstract int getEndOffset() throws DOMException;
    
    public abstract boolean getCollapsed() throws DOMException;
    
    public abstract Node getCommonAncestorContainer() throws DOMException;
    
    public abstract void setStart(Node p0, int p1) throws RangeException, DOMException;
    
    public abstract void setEnd(Node p0, int p1) throws RangeException, DOMException;
    
    public abstract void setStartBefore(Node p0) throws RangeException, DOMException;
    
    public abstract void setStartAfter(Node p0) throws RangeException, DOMException;
    
    public abstract void setEndBefore(Node p0) throws RangeException, DOMException;
    
    public abstract void setEndAfter(Node p0) throws RangeException, DOMException;
    
    public abstract void collapse(boolean p0) throws DOMException;
    
    public abstract void selectNode(Node p0) throws RangeException, DOMException;
    
    public abstract void selectNodeContents(Node p0) throws RangeException, DOMException;
    
    public abstract short compareBoundaryPoints(short p0, Range p1) throws DOMException;
    
    public abstract void deleteContents() throws DOMException;
    
    public abstract DocumentFragment extractContents() throws DOMException;
    
    public abstract DocumentFragment cloneContents() throws DOMException;
    
    public abstract void insertNode(Node p0) throws DOMException, RangeException;
    
    public abstract void surroundContents(Node p0) throws DOMException, RangeException;
    
    public abstract Range cloneRange() throws DOMException;
    
    public abstract String toString() throws DOMException;
    
    public abstract void detach() throws DOMException;
}
